/* Copyright (c) 2006, NIF File Format Library and Tools
All rights reserved.  Please see niflib.h for licence. */

#ifndef _MATCHGROUP_H_
#define _MATCHGROUP_H_

#include "../NIF_IO.h"

namespace Niflib {


/*!
 * Group of vertex indices of vertices that match.
 */
struct MatchGroup {
	/*! Default Constructor */
	NIFLIB_API MatchGroup();
	/*! Copy Constructor */
	NIFLIB_API MatchGroup( const MatchGroup & src );
	/*! Copy Operator */
	NIFLIB_API MatchGroup & operator=( const MatchGroup & src );
	/*! Default Destructor */
	NIFLIB_API ~MatchGroup();
	/*!
	 * Number of vertices in this group.
	 */
	mutable unsigned short numVertices;
	/*!
	 * The vertex indices.
	 */
	vector<unsigned short > vertexIndices;
};

}
#endif
